package com.ruoyi.web.controller.agentcenter;

import com.nsgk.agentcentersdk.api.NSApiResult;
import com.nsgk.agentcentersdk.api.NSSDK;
import com.nsgk.agentcentersdk.api.NSSDKServer;
import com.nsgk.agentcentersdk.core.NSProtocol;
import com.nsgk.agentcentersdk.core.NSReportObject;
import com.nsgk.agentcentersdk.entity.NSContractionEntity;
import com.nsgk.agentcentersdk.err.NSErrGlobal;
import com.nsgk.agentcentersdk.err.NSErrno;
import com.nsgk.agentcentersdk.err.NSException;
import com.ruoyi.agentcenter.object.ContractionSession;
import com.ruoyi.agentcenter.object.Message;
import com.ruoyi.agentcenter.object.Result;
import com.ruoyi.agentcenter.object.Session;
import com.ruoyi.agentcenter.service.IAgentCenter;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.utils.EventBusEngine;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;

/**
 * 上报接口Controller
 * 
 * @author zhao
 */
@RestController
@RequestMapping("/agentcenter/api")
public class AgentCenterController extends BaseController
{
    @Autowired
    private IAgentCenter agentCenter;

    @PostMapping("/test")
    public NSApiResult test(HttpServletRequest request)
    {
        NSSDKServer server;
        NSReportObject<NSContractionEntity> recv;

        NSSDK.InitServer(RuoYiConfig.Secret.privateKey);
        server = NSSDK.InstanceServer();
        recv = server.Recv(request, NSContractionEntity.class);

        return server.Resp(0, "测试成功", recv.getDataStr());
    }

    @PostMapping("/report")
    public NSApiResult report(HttpServletRequest request)
    {
        NSSDKServer server;

        NSSDK.InitServer(RuoYiConfig.Secret.privateKey);
        server = NSSDK.InstanceServer();
        try
        {
            Result<?> result = agentCenter.postHandle(server, request);
            return server.Resp(result.getCode(), result.getMessage(), result.getData());
        }
        catch(NSException e)
        {
            return server.Fail(e.getErrno(), e.getMessage());
        }
        catch(Exception e)
        {
            return server.Fail(NSErrno.ERRNO_ERROR, e.getMessage());
        }
    }
}
